MrMap/urls.py
from django.contrib import admin
from django.urls import path, include

from MrMap.settings import DEBUG

urlpatterns = [
    # path('', login, name="login"),
    # path('logout/', logout, name='logout'),
    # path('password-reset/', password_reset, name='password-reset'),
    # path('register/', register, name='register'),
    # path('activate/<activation_hash>', activate_user, name='activate-user'),
    path('admin/', admin.site.urls),
    path('', include('users.urls')),
    path('structure/', include('structure.urls')),
    path('resource/', include('service.urls')),
    path('monitoring/', include('monitoring.urls')),
    path('editor/', include('editor.urls')),
    path('captcha/', include('captcha.urls')),
    path("i18n/", include("django.conf.urls.i18n")),
    path('api/', include('api.urls')),
    path('csw/', include('csw.urls'))
]

if DEBUG:
    import debug_toolbar
    urlpatterns.append(
        path('__debug__/', include(debug_toolbar.urls))
    )

handler404 = "structure.views.handler404"
handler500 = "structure.views.handler500"

api/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 15.08.19

"""

from django.urls import path, include


# Routers provide an easy way of automatically determining the URL conf.
from rest_framework import routers

from api.views import *

router = routers.DefaultRouter()
# catalogue api
router.register('catalogue', CatalogueViewSet, basename="catalogue")
router.register('suggestion', SuggestionViewSet, basename="suggestion")
router.register('category', CategoryViewSet, basename="category")
# modular parts of api
router.register('organization', OrganizationViewSet, basename="organization")
router.register('pending-task', PendingTaskViewSet, basename="pending-task")
router.register('metadata', MetadataViewSet, basename="metadata")
router.register('service', ServiceViewSet, basename="service")
router.register('layer', LayerViewSet, basename="layer")
router.register('group', GroupViewSet, basename="group")
router.register('monitoring', MonitoringViewSet, basename="monitoring")

app_name = "api"
urlpatterns = [
    path("", include(router.urls)),
    path("menu", menu_view, name="menu"),
    path("generate-token", generate_token, name="generate-token"),
]

csw/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 05.05.20

"""
from django.urls import path

from csw.views import *

app_name = 'csw'
urlpatterns = [
    path('', get_csw_results, name='get-csw-results'),
    path('harvest/<metadata_id>', harvest_catalogue, name='harvest-catalogue'),
]

editor/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 09.07.19

"""
from django.urls import path
from editor.autocompletes import KeywordAutocomplete, CategoryAutocomplete, DatasetMetadataAutocomplete, \
    ReferenceSystemAutocomplete, ServiceMetadataAutocomplete
from editor.views import *

app_name = 'editor'
urlpatterns = [
    # ToDo: move the autocomplete paths behind view to secure them
    path('keyword-autocomplete/', KeywordAutocomplete.as_view(create_field="keyword"), name="keyword-autocomplete"),
    path('category-autocomplete/', CategoryAutocomplete.as_view(), name="category-autocomplete"),
    path('metadata-autocomplete/', DatasetMetadataAutocomplete.as_view(), name="metadata-autocomplete"),
    path('service-autocomplete/', ServiceMetadataAutocomplete.as_view(), name="service-autocomplete"),
    path('reference-system-autocomplete/', ReferenceSystemAutocomplete.as_view(), name="reference-system-autocomplete"),

    path('metadata/<metadata_id>', edit, name='edit'),

    path('dataset/wizard', add_new_dataset_wizard, name="dataset-metadata-wizard-new"),
    path('dataset/wizard/<metadata_id>', edit_dataset_wizard, name="dataset-metadata-wizard-instance"),

    path('dataset/remove/<metadata_id>', remove_dataset, name='remove-dataset-metadata'),
    path('access/<object_id>', edit_access, name='edit_access'),
    path('access/<metadata_id>/<group_id>/geometry-form/', access_geometry_form, name='access_geometry_form'),
    path('restore/<metadata_id>', restore, name='restore'),
    path('restore-dataset-metadata/<metadata_id>', restore_dataset_metadata, name='restore-dataset-metadata'),
]

service/urls.py
from django.urls import path

from service.views import *

app_name = 'resource'
urlpatterns = [
    path('', index, name='index'),

    path('metadata/<metadata_id>', get_service_metadata, name='get-service-metadata'),
    path('metadata/<metadata_id>/subscribe', metadata_subscription_new, name='subscription-new'),
    path('metadata/dataset/<metadata_id>', get_dataset_metadata, name='get-dataset-metadata'),
    path('metadata/html/<metadata_id>', get_metadata_html, name='get-metadata-html'),

    path('metadata/<metadata_id>/operation', get_operation_result, name='metadata-proxy-operation'),
    path('metadata/<metadata_id>/legend/<int:style_id>', get_metadata_legend, name='metadata-proxy-legend'),

    path('preview/<metadata_id>', get_service_preview, name='get-service-metadata-preview'),

    path('new-update/<metadata_id>', new_pending_update_service, name='new-pending-update'),
    path('pending-update/<metadata_id>', pending_update_service, name='pending-update'),
    path('dismiss-pending-update/<metadata_id>', dismiss_pending_update_service, name='dismiss-pending-update'),
    path('run-update/<metadata_id>', run_update_service, name='run-update'),

    path('remove/<metadata_id>', remove, name='remove'),
    path('activate/<metadata_id>', activate, name='activate'),
    path('add/', add, name='add'),

    path('pending-tasks/', pending_tasks, name="pending-tasks"),
    path('wms-table/', wms_table, name="wms-table"),
    path('wfs-table/', wfs_table, name="wfs-table"),
    path('wms-table/', wms_table, name="wms-table"),
    path('csw-table/', csw_table, name="csw-table"),
    path('dataset-table/', datasets_table, name="dataset-table"),

    path('wms/', wms_index, name='wms-index'),
    path('wfs/', wfs_index, name='wfs-index'),
    path('csw/', csw_index, name='csw-index'),
    path('datasets/', datasets_index, name='datasets-index'),

    path('detail/<object_id>', detail, name='detail'),

    path('logs/', logs_view, name='logs-view'),
    path('logs/download/', logs_download, name='logs-download'),
]

users/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 28.05.19

"""

from django.urls import path

from .views import *
urlpatterns = [
    path('', login_view, name="login"),
    path('home', home_view, name="home"),
    path('account', account, name="account"),
    path('users/password/edit/', password_change, name="password-change"),
    path('users/edit/', account_edit, name="account-edit"),
    path('logout/', logout_view, name='logout'),
    path('password-reset/', password_reset, name='password-reset'),
    path('register/', register, name='register'),
    path('activate/<activation_hash>', activate_user, name='activate-user'),

    path('subscription', subscription_index_view, name='subscription-index'),
    path('subscription/new', subscription_new_view, name='subscription-new'),
    path('subscription/<subscription_id>/edit', subscription_edit_view, name='subscription-edit'),
    path('subscription/<subscription_id>/remove', subscription_remove, name='subscription-remove'),
]

service/views.py
import base64
import io
from io import BytesIO

from PIL import Image, UnidentifiedImageError
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.core.exceptions import ObjectDoesNotExist
from django.db import transaction
from django.http import HttpRequest, HttpResponse, StreamingHttpResponse, QueryDict, HttpResponseRedirect
from django.shortcuts import render, get_object_or_404, redirect
from django.utils.translation import gettext_lazy as _
from django.views.decorators.csrf import csrf_exempt
from requests.exceptions import ReadTimeout
from django.utils import timezone
from MrMap.cacher import PreviewImageCacher
from MrMap.consts import *
from MrMap.decorator import check_permission, log_proxy, check_ownership, resolve_metadata_public_id
from MrMap.messages import SERVICE_UPDATED, \
    SERVICE_NOT_FOUND, SECURITY_PROXY_ERROR_MISSING_REQUEST_TYPE, SERVICE_DISABLED, SERVICE_LAYER_NOT_FOUND, \
    SECURITY_PROXY_NOT_ALLOWED, CONNECTION_TIMEOUT, SERVICE_CAPABILITIES_UNAVAILABLE, \
    SUBSCRIPTION_CREATED_TEMPLATE, SUBSCRIPTION_ALREADY_EXISTS_TEMPLATE
from MrMap.responses import DefaultContext
from MrMap.settings import SEMANTIC_WEB_HTML_INFORMATION
from service.filters import MetadataWmsFilter, MetadataWfsFilter, MetadataDatasetFilter, MetadataCswFilter
from service.forms import UpdateServiceCheckForm, UpdateOldToNewElementsForm, RemoveServiceForm, \
    ActivateServiceForm
from service.helper import service_helper, update_helper
from service.helper.common_connector import CommonConnector
from service.helper.enums import OGCServiceEnum, OGCOperationEnum, OGCServiceVersionEnum, MetadataEnum, DocumentEnum
from service.helper.logger_helper import prepare_proxy_log_filter
from service.helper.ogc.operation_request_handler import OGCOperationRequestHandler
from service.helper.service_comparator import ServiceComparator
from service.helper.service_helper import get_resource_capabilities
from service.settings import DEFAULT_SRS_STRING, PREVIEW_MIME_TYPE_DEFAULT, PLACEHOLDER_IMG_PATH
from service.tables import WmsTableWms, WmsLayerTableWms, WfsServiceTable, PendingTasksTable, UpdateServiceElements, \
    DatasetTable, CswTable
from service.tasks import async_log_response
from service.models import Metadata, Layer, Service, Document, Style, ProxyLog
from service.utils import collect_contact_data, collect_metadata_related_objects, collect_featuretype_data, \
    collect_layer_data, collect_wms_root_data, collect_wfs_root_data
from service.wizards import NEW_RESOURCE_WIZARD_FORMS, NewResourceWizard
from structure.models import MrMapUser, PendingTask
from structure.permissionEnums import PermissionEnum
from users.helper import user_helper
from django.urls import reverse

from users.models import Subscription


def _is_updatecandidate(metadata: Metadata):
    # get service object
    if metadata.is_metadata_type(MetadataEnum.FEATURETYPE):
        service = metadata.featuretype.parent_service
    elif metadata.is_metadata_type(MetadataEnum.DATASET):
        return False
    else:
        service = metadata.service
    # proof if the requested metadata is a update_candidate --> 404
    if service.is_root:
        if service.is_update_candidate_for is not None:
            return True
    else:
        if service.parent_service.is_update_candidate_for is not None:
            return True
    return False


def _prepare_wms_table(request: HttpRequest, current_view: str, user_groups):
    """ Collects all wms service data and prepares parameter for rendering

    Args:
        request (HttpRequest): The incoming request
    Returns:
         params (dict): The rendering parameter
    """
    # whether whole services or single layers should be displayed
    if 'show_layers' in request.GET and request.GET.get("show_layers").lower() == 'on':
        show_service = False
    else:
        show_service = True

    queryset = Metadata.objects.filter(
        service__service_type__name=OGCServiceEnum.WMS.value,
        created_by__in=user_groups,
        is_deleted=False,
        service__is_update_candidate_for=None
    ).prefetch_related(
        "contact",
        "service",
        "service__created_by",
        "service__published_for",
        "service__service_type",
        "external_authentication",
        "service__parent_service__metadata",
        "service__parent_service__metadata__external_authentication",
    ).order_by("title")

    if show_service:
        wms_table = WmsTableWms(request=request,
                                queryset=queryset,
                                filter_set_class=MetadataWmsFilter,
                                order_by_field='swms',  # swms = sort wms
                                current_view=current_view,
                                param_lead='wms-t', )
    else:
        wms_table = WmsLayerTableWms(request=request,
                                     queryset=queryset,
                                     filter_set_class=MetadataWmsFilter,
                                     order_by_field='swms',  # swms = sort wms
                                     current_view=current_view,
                                     param_lead='wms-t', )

    return {
        "wms_table": wms_table,
    }


def _prepare_wfs_table(request: HttpRequest, current_view: str, user_groups):
    """ Collects all wfs service data and prepares parameter for rendering

    Args:
        request (HttpRequest): The incoming request
        user (MrMapUser): The performing user
    Returns:
         params (dict): The rendering parameter
    """
    queryset = Metadata.objects.filter(
        service__service_type__name=OGCServiceEnum.WFS.value,
        created_by__in=user_groups,
        is_deleted=False,
        service__is_update_candidate_for=None
    ).prefetch_related(
        "contact",
        "service",
        "service__created_by",
        "service__published_for",
        "service__service_type",
        "external_authentication",
        "service__parent_service__metadata",
        "service__parent_service__metadata__external_authentication",
    ).order_by("title")

    wfs_table = WfsServiceTable(request=request,
                                queryset=queryset,
                                filter_set_class=MetadataWfsFilter,
                                order_by_field='swfs',  # swms = sort wms
                                current_view=current_view,
                                param_lead='wfs-t',)

    return {
        "wfs_table": wfs_table,
    }


def _prepare_csw_table(request: HttpRequest, current_view: str, user_groups):
    """ Collects all wfs service data and prepares parameter for rendering

    Args:
        request (HttpRequest): The incoming request
        user (MrMapUser): The performing user
    Returns:
         params (dict): The rendering parameter
    """
    queryset = Metadata.objects.filter(
        metadata_type=MetadataEnum.CATALOGUE.value,
        created_by__in=user_groups,
        is_deleted=False,
        service__is_update_candidate_for=None
    ).prefetch_related(
        "contact",
        "service",
        "service__created_by",
        "service__published_for",
        "service__service_type",
        "external_authentication",
    ).order_by("title")

    table = CswTable(request=request,
                     queryset=queryset,
                     filter_set_class=MetadataCswFilter,
                     order_by_field='scsw',  # scsw = sort csw
                     current_view=current_view,
                     param_lead='csw-t',)

    return {
        "csw_table": table,
    }


def _prepare_dataset_table(request: HttpRequest, user: MrMapUser, current_view: str, user_groups):
    dataset_table = DatasetTable(request=request,
                                 filter_set_class=MetadataDatasetFilter,
                                 queryset=user.get_datasets_as_qs(user_groups=user_groups),
                                 current_view=current_view,
                                 param_lead='dataset-t',)
    return {
            "dataset_table": dataset_table,
    }


@login_required
@check_permission(
    PermissionEnum.CAN_REGISTER_RESOURCE
)
def add(request: HttpRequest):
    """ Renders wizard page configuration for service registration

        Args:
            request (HttpRequest): The incoming request
            user (User): The performing user
        Returns:
             params (dict): The rendering parameter
    """
    return NewResourceWizard.as_view(
        form_list=NEW_RESOURCE_WIZARD_FORMS,
        current_view=request.GET.get('current-view'),
        title=_(format_html('<b>Add New Resource</b>')),
        id_wizard='add_new_resource_wizard',
    )(request=request)


@login_required
def index(request: HttpRequest, update_params: dict = None, status_code: int = 200, ):
    """ Renders an overview of all wms and wfs

    Args:
        request (HttpRequest): The incoming request
        update_params: (Optional) the update_params dict
        status_code:
    Returns:
         A view
    """
    user = user_helper.get_user(request)
    user_groups = user.get_groups()

    # Default content
    template = "views/index.html"

    # get pending tasks
    pt = PendingTask.objects.filter(created_by__in=user_groups).order_by('id')
    pt_table = PendingTasksTable(data=pt,
                                 orderable=False,
                                 request=request,)

    params = {
        "pt_table": pt_table,
        "current_view": "resource:index",
    }

    params.update(_prepare_wms_table(request=request, current_view='resource:index', user_groups=user_groups))
    params.update(_prepare_wfs_table(request=request, current_view='resource:index', user_groups=user_groups))
    params.update(_prepare_csw_table(request=request, current_view='resource:index', user_groups=user_groups))

service/templates/includes/wfs/element_accordion.html
{% extends 'sceletons/accordion.html' %}
{% load static i18n %}
{% block accordion-button-title %}
<i class="fa" aria-hidden="true"></i> {{ element.name }}
{% endblock %}

{% block accordion-body %}
    <table class="table {{THEME.TABLE.HOVER}} {{THEME.TABLE.STRIPED}} {{THEME.TABLE.BG}} {{THEME.TABLE.BORDER}} {{THEME.TABLE.BORDERED}}">
        <tr>
            <th scope="row">{% trans 'Name' %}</th>
            <td>{{ element.name }}</td>
        </tr>
        <tr>
            <th scope="row">{% trans 'Type' %}</th>
            <td>{{ element.type }}</td>
        </tr>
    </table>
{% endblock %}

service/templates/includes/wfs/featuretype_accordion.html
{% extends 'sceletons/accordion.html' %}
{% load static i18n %}
{% block accordion-button-title %}
<i class="fa" aria-hidden="true"></i> {{ featuretype.metadata.title }}
{% endblock %}

{% block accordion-body %}
    <div id="id_content_service_{{featuretype.metadata.id}}">
        {% include 'includes/loading_spinner.html' %}
    </div>
    <script type="application/javascript">
        var accordionButton = $('#id_accordion_btn_{{id_accordion}}_{{id_accordion_combined}}');

        accordionButton.click(function() {
          if ( accordionButton.hasClass('collapsed') ) {
            $.get( '{% url 'resource:detail' featuretype.metadata.id %}?no-base', function( data ) {
                $( "#id_content_service_{{featuretype.metadata.id}}" ).html( data );
                $(function () {
                  $('[data-toggle="tooltip"]').tooltip()
                })
            });
          }
        });
    </script>

{% endblock %}

service/templates/includes/wfs/featuretype_detail.html
{% extends 'sceletons/card.html' %}
{% load i18n %}

{% block card-header-title-left %}
<h4 class="mb-1 mr-3" style="display: inline;">
    {% autoescape off %}{{THEME.ICONS.FEATURETYPE}}{% endautoescape %}
    <strong>{{ service.metadata.title }}</strong>
</h4>
<span class="d-inline-block" tabindex="0" data-toggle="tooltip" title="{% trans 'Open in new tab' %}">
    <h6 style="display: inline;"><a href="{% url 'resource:detail' service_md.id %}">{{THEME.ICONS.EXTERNAL_LINK}}</a></h6>
</span>
{% endblock %}
{% block card-header-title-right %}

{% endblock %}

{% load i18n %}
{% block card-body %}
    <div class="row mb-2 ">
        <div class="col-sm mb-2 text-center">
            {% if 'can_edit_metadata' in user_permissions %}
                <div class="dropdown">
                  <button class="btn {{THEME.CARD.BTN_SECONDARY_COLOR}} dropdown-toggle" type="button" id="id_edit_service_{{service.id}}_dropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    {% autoescape off %}{{THEME.ICONS.EDIT}}{% endautoescape %} {% trans 'Edit featuretype' %}
                  </button>
                  <div class="dropdown-menu" aria-labelledby="id_edit_service_{{service.id}}_dropdown">
                    <a class="dropdown-item" href="{% url 'editor:edit' service.metadata.id %}?current-view={{current_view}}&current-view-arg={{service.metadata.id}}">{% autoescape off %}{{THEME.ICONS.METADATA}}{% endautoescape %} {% trans 'Metadata' %}</a>
                    <a class="dropdown-item" href="{% url 'editor:edit_access' service.metadata.id %}">{% autoescape off %}{{THEME.ICONS.ACCESS}}{% endautoescape %} {% trans 'Access' %}</a>
                  </div>
                </div>
            {% endif %}
            </div><!--</col>-->
            {% if dataset_metadatas %}
                <div class="col-sm mb-2 text-center">
                    <div class="dropdown">
                <button class="btn {{THEME.CARD.BTN_INFO_COLOR}} dropdown-toggle" type="button" id="id_dataset_metadata_dropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    {% autoescape off %}{{THEME.ICONS.METADATA}}{% endautoescape %} {% trans 'Dataset Metadata' %}
                </button>

                <div class="dropdown-menu" aria-labelledby="id_dataset_metadata_dropdown">
                    {% for dataset in dataset_metadatas %}
                    <a class="dropdown-item" target="_blank" href="{{ dataset.html_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.NEWSPAPER}}{% endautoescape %} {% trans 'HTML' %}</a>
                    <a class="dropdown-item" target="_blank" href="{{ dataset.service_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.CAPABILITIES}}{% endautoescape %} {% trans 'XML' %}</a>
                    <a class="dropdown-item" href="{% url 'editor:dataset-metadata-wizard-instance' dataset.id %}?current-view={{current_view}}&current-view-arg={{service.metadata.id}}">{% autoescape off %}{{THEME.ICONS.EDIT}}{% endautoescape %} {% trans 'Edit' %}</a>
                    {% endfor %}
                </div>

            </div>
                </div><!--</col>-->
            {% endif %}
            <div class="col-sm mb-2 text-center">
                <div class="dropdown">
                  <button class="btn {{THEME.CARD.BTN_INFO_COLOR}} dropdown-toggle" type="button" id="id_metadata_dropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    {% autoescape off %}{{THEME.ICONS.METADATA}}{% endautoescape %} {% trans 'Service Metadata' %}
                  </button>
                  <div class="dropdown-menu" aria-labelledby="id_metadata_dropdown">
                      <a class="dropdown-item" target="_blank" href="{{ service_md.html_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.NEWSPAPER}}{% endautoescape %} {% trans 'HTML' %}</a>
                      <a class="dropdown-item" target="_blank" href="{{ service_md.service_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.CAPABILITIES}}{% endautoescape %} {% trans 'XML' %}</a>
                  </div>
                </div>
            </div>
            <div class="col-sm mb-2 text-center">
            {% if 'can_edit_metadata' in user_permissions %}
                <a class="btn {{THEME.CARD.BTN_WARNING_COLOR}}" href="{% url 'editor:restore' service.metadata.id %}?current-view={{current_view}}&current-view-arg={{service.metadata.id}}">{% autoescape off %}{{THEME.ICONS.UNDO}}{% endautoescape %} {% trans 'Restore metadata' %}</a>
            {% endif %}
            </div><!--</col>-->
        </div><!--</row>-->
        <div class="row mb-2 ">
        <div class="col">


        {% include 'includes/wfs/featuretype_detail_table.html' %}
        {% with service as featuretype %}
            {% with service.id as id_accordion  %}
                {% with id_accordion_combined='elements' %}
                    {% include 'includes/wfs/show_featuretype_elements_accordion.html' %}
                {% endwith %}
            {% endwith %}
        {% endwith %}

        </div><!--</col>-->
</div><!--</row>-->
{% endblock %}

service/templates/includes/wfs/featuretype_detail_table.html
{% extends 'sceletons/table.html' %}
{% load i18n static %}
{% block table %}
    <tr>
        <th scope="row">{% trans 'Parent service' %}</th>
        <td>
            <a class="{{THEME.TABLE.LINK_COLOR}}" href="{% url 'resource:detail' service.parent_service.metadata.id %}" title="{{ service.parent_service.metadata.uuid }}">
                {{ service.parent_service.metadata.title }}
            </a>
        </td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Easy ID' %}</th>
        <td>{{ service.metadata.public_id }}</td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Title' %}</th>
        <td>{{ service.metadata.title }}</td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Abstract' %}</th>
        <td>{{ service.metadata.abstract }}</td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Keywords' %}</th>
        <td class="listable-container">
            {% for kw in service.metadata.keywords.all %}
                    <span class="badge {{THEME.TABLE.PILL_BADGE_INFO_COLOR}}">{{ kw }}</span>
            {% empty %}
                {% trans 'No keywords provided' %}
            {% endfor %}
        </td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Is searchable' %}</th>
        <td>
            {% if service.searchable %}
            <em class='fas fa-check text-success'></em>
            {% else %}
            <em class='fas fa-times text-danger'></em>
            {% endif %}
        </td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Access secured' %}</th>
        <td>
            {% if service.metadata.is_secured %}
            <em class='fas fa-check text-success'></em>
            {% else %}
            <em class='fas fa-times text-danger'></em>
            {% endif %}
        </td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Bounding box' %}</th>
        <td>
            {% if service.bbox_lat_lon.area > 0.0 %}
            <div id="{{ service.id.hex }}_map" class="map-view" style="height: 40vh; min-height: 200px;"></div>
            {% with id_map=service.id.hex bbox=service.bbox_lat_lon  %}
                {% include 'leaflet/leaflet-client.html' %}
                <script type="text/javascript">
                    initializeLeafletClient();
                </script>
            {% endwith %}

            {% else %}
                {% trans 'No spatial data provided!' %}
            {% endif %}
        </td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Default reference system:' %}</th>
        <td>
            <span class="badge {{THEME.TABLE.PILL_BADGE_INFO_COLOR}}">{{ service.default_srs.prefix }}{{ service.default_srs.code }}</span>
        </td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Additional reference systems:' %}</th>
        <td class="listable-container">
            {% for rs in service.metadata.reference_system.all %}
                <span class="badge {{THEME.TABLE.PILL_BADGE_INFO_COLOR}}">{{ rs.prefix }}{{ rs.code }}</span>
            {% empty %}
                {% trans 'No additional reference systems provided' %}
            {% endfor %}
        </td>
    </tr>
    <tr>
        <th scope="row">{% trans 'Mime types:' %}</th>
        <td class="col-sm-10">
            {% with service.id as id_accordion %}
                {% for key, values in mime_types.items %}
                    {% with key as id_accordion_combined and 'btn-link' as button_type %}
                        {% include 'includes/wms/sublayer_mime_type_table.html' %}
                    {% endwith %}
                {% endfor %}
            {% endwith %}
        </td>
    </tr>
{% endblock %}

service/templates/includes/wfs/show_featuretype_elements_accordion.html
{% extends 'sceletons/accordion.html' %}

{% load static i18n %}
{% if service.elements.all|length > 0 %}
    {% block accordion-button-title %}
        <i class="fa" aria-hidden="true"></i> {% trans 'Show elements' %} <span class="badge {{THEME.ACCORDION.PILL_BADGE_INFO_COLOR}}">{{  service.elements.all|length }}</span>
    {% endblock %}

    {% block accordion-body %}
        {% for element in service.elements.all %}
            {% with element.name as id_accordion  %}
                {% with "sub_element" as id_accordion_combined %}
                    {% include 'includes/wfs/element_accordion.html' %}
                {% endwith %}
            {% endwith %}
        {% endfor %}
    {% endblock %}
{% endif %}

service/templates/includes/wfs/show_featuretypes_accordion.html
{% extends 'sceletons/accordion.html' %}

{% load static i18n %}
{% if featuretypes|length > 0 %}
    {% block accordion-button-title %}
        <i class="fa" aria-hidden="true"></i> {% trans 'Show featuretypes' %} <span class="badge {{THEME.ACCORDION.PILL_BADGE_LIGHT_COLOR}}">{{ featuretypes|length }}</span>
    {% endblock %}

    {% block accordion-body %}
        {% for featuretype in featuretypes %}
            {% with featuretype.id as id_accordion %}
                {% with "element" as id_accordion_combined %}
                    {% include 'includes/wfs/featuretype_accordion.html' %}
                {% endwith %}
            {% endwith %}
        {% endfor %}
    {% endblock %}
{% endif %}